<!DOCTYPE html>
<html lang="en">
<head>

    <title>Introduction to Cocoa Drawing Guide</title>
    <meta http-equiv="X-UA-Compatible" content="IE=7">
    <meta charset="utf-8">
    <meta id="book-resource-type" name="book-resource-type" content="Guide">
    <meta scheme="apple_ref" id="identifier" name="identifier" content="//apple_ref/doc/uid/TP40003290">
    <meta id="document-version" name="document-version" content="3.1.0">
    <meta id="build" name="build" content="c1e4c7a89af8f899a21cfa81fc33ba42" />
    <meta id="chapterId" name="chapterId" content="TP40003290-CH201">
    <meta id="date" name="date" content="2012-09-19">
    <meta id="description" name="description" content="Explains how to use Cocoa to draw your application's user interface.">
    <meta id="book-title" name="book-title" content="Cocoa Drawing Guide">
    <meta id="book-root" name="book-root" content="../">
    <meta id="book-json" name="book-json" content="../book.json">
    <meta id="devcenter" name="devcenter" content="Mac Dev Center">
    <meta id="devcenter-url" name="devcenter-url" content="http://developer.apple.com/devcenter/mac">
    <meta id="reflib" name="reflib" content="Documentation Archive">
    <meta id="book-assignments" name="book-assignments" content="{Type/Guide}, {Topic/Graphics & Animation/2D Drawing}">
    
    
    <meta id="copyright" name="copyright" content="Copyright 2018 Apple Inc. All Rights Reserved.">
    <meta id="xcode-display" name="xcode-display" content="render">
    <meta id="IndexTitle" name="IndexTitle" content="Cocoa Drawing Guide: Introduction to Cocoa Drawing Guide">
    <meta id="resources-uri" name="resources-uri" content="../../../../../Resources/1282">
    <link id="book-index-page" rel="Start" title="Cocoa Drawing Guide" type="text/html" href="../index.html">
    <link id="next-page" rel="Next" type="text/html" href="../DrawingEnviron/DrawingEnviron.html">
    <link id="previous-page" rel="Prev" type="text/html" href="">
    <link rel="stylesheet" type="text/css" href="../../../../../Resources/1282/CSS/screen.css">
    
    <!-- xcode_css -->
    <link rel="stylesheet" type="text/css" href="../../../../../Resources/1282/CSS/feedback.css">
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">
	<meta id="platforms" name="platforms" content="OS X">
</head>    
<body><a name="//apple_ref/doc/uid/TP40003290-CH201" title="Introduction to Cocoa Drawing Guide"></a>
    <div id="_omniture_top">
    <!-- SiteCatalyst code version: H.8. Copyright 1997-2006 Omniture, Inc. -->
    <script type="text/javascript">
    /* RSID: */
    var s_account="appleglobal,appleusdeveloper,dappdeveloperlib"
    </script>

    <script type="text/javascript" src="https://www.apple.com/metrics/scripts/s_code_h.js"></script>
    <script type="text/javascript">
    s.pageName=AC.Tracking.pageName();
    s.channel="www.us.developer"

    /************* DO NOT ALTER ANYTHING BELOW THIS LINE ! **************/
    var s_code=s.t();if(s_code)document.write(s_code)</script>
    <!-- End SiteCatalyst code version: H.8. -->
    </div>

    <div id="adcHeader" class="hideOnPrint hideInXcode">
        <div id='ssi_Header' class="hideInXcode unified">
            <a id="ssi_LibraryTitle" href='../../../../../navigation/'>Documentation Archive</a>
            <a id="ssi_AppleDeveloperConnection" href='https://developer.apple.com/'>Developer</a>
            <div id='ssi_SearchButton' role="button" title="Search">Search</div>
        </div>
        <form id='ssi_SearchMenu' method='get' action='../../../../../search/' accept-charset='utf-8'>
            <label for='adcsearch'>Search Documentation Archive</label>
            
            
    
            <input type='search' id='ssi_SearchField' name='q' accesskey='s' results='5' />
        </form>
    </div>

    <header id="header">
        <div id="title" role="banner">
            <h1>Cocoa Drawing Guide</h1>
            <span id="file_links">
                <a id="PDF_link" role="button" tabindex='4' rel="alternate" title="Download PDF"><span id="pdf_icon"></span>PDF</a>
                <a id="Companion_link" role="button" tabindex='3' title="Download Companion File"><span id="companion_icon"></span>Companion File</a>
            </span>
        </div>
        <ul id="headerButtons" class="hideOnPrint" role="toolbar">
            <li id="toc_button" style="display:none">
                <button tabindex="5" id="table_of_contents" class="open" role="checkbox" aria-label="Show Table of Contents"><span class="disclosure"></span>Table of Contents</button>
            </li>
            <li id="jumpto_button" style="display:none" role="navigation"><select tabindex="6" id="jumpTo"><option value="top">Jump To&#133;</option></select></li>
            <li id="downloadSample_button" style="display:none">
                <a id="Sample_link"><button id="Sample_button">Download Sample Code</button></a>
            </li>
        </ul>
    </header>
    <nav id="tocContainer" tabindex="7">
        <ul id="toc" role="tree"></ul>
    </nav>

    <article id="contents" tabindex="0" role="main">
        <div id="pageNavigationLinks_top" class="pageNavigationLinks">
            <a class='nextLink' rel='next' href='../DrawingEnviron/DrawingEnviron.html'>Next</a>
        </div>
        <a id="top" name="top"></a>
        <a id="INDEX" href="../index.html" style="display:none;"></a>
        
        <a name="//apple_ref/doc/uid/TP40003290" title="Introduction to Cocoa Drawing Guide"></a><a name="//apple_ref/doc/uid/TP40003290-CH201-SW1" title="Introduction to Cocoa Drawing Guide"></a><h1 id="pageTitle">Introduction to Cocoa Drawing Guide</h1><a name="//apple_ref/doc/uid/TP40003290-CH201-DontLinkElementID_1"></a><p>High-quality graphics are an important part of a well-designed application. In fact, high-quality graphics is one of the things that sets OS X apart from many other operating systems. While some operating systems rely on flat colors and rectangular objects, OS X uses color, transparency, and its advanced compositing system to give programs a more fluid and inviting appearance. </p><a name="//apple_ref/doc/uid/TP40003290-CH201-DontLinkElementID_2" title="At a Glance"></a><h2 class="jump">At a Glance</h2>
<p>This document is intended for developers who are new to drawing custom content using Cocoa. More advanced Cocoa developers may also want to read this book for tips on how to perform specific tasks. </p>
<p>Before you begin reading this document, you should be familiar with the basic concepts of how to create a Cocoa application. This includes how to create new projects in Xcode, how to create a simple nib file, and how to manipulate Cocoa objects. You do not need any understanding of graphics programming in general, although such knowledge definitely helps. </p>
<p>This <a name="//apple_ref/doc/uid/TP40003290-CH201-DontLinkElementID_605"></a>document assumes that you are familiar with the basic concepts for creating a Cocoa application. This book also assumes that you have a basic understanding of the Objective-C programming language. </p>
<p>This document has the following chapters:</p>
<ul class="ul"><li class="li"><p><span class="content_text"><a href="../DrawingEnviron/DrawingEnviron.html#//apple_ref/doc/uid/TP40003290-CH202-BBCJDGHJ" data-renderer-version="1">Overview of Cocoa Drawing</a></span> introduces drawing-related concepts and the Cocoa support for drawing.</p></li>
<li class="li"><p><span class="content_text"><a href="../GraphicsContexts/GraphicsContexts.html#//apple_ref/doc/uid/TP40003290-CH203-BCIJFBJJ" data-renderer-version="1">Graphics Contexts</a></span> describes the drawing environment and provides examples of how you configure the environment to suit your needs. </p></li>
<li class="li"><p><span class="content_text"><a href="../Transforms/Transforms.html#//apple_ref/doc/uid/TP40003290-CH204-BCIDJJBI" data-renderer-version="1">Coordinate Systems and Transforms</a></span> describes the coordinate systems used for drawing and provides examples of how you manipulate your content using transforms. </p></li>
<li class="li"><p><span class="content_text"><a href="../Color/Color.html#//apple_ref/doc/uid/TP40003290-CH205-BAJDFIFE" data-renderer-version="1">Color and Transparency</a></span> provides basic information about color and shows you how to use the color-related Cocoa objects. </p></li>
<li class="li"><p><span class="content_text"><a href="../Paths/Paths.html#//apple_ref/doc/uid/TP40003290-CH206-BBCHFJJG" data-renderer-version="1">Paths</a></span> describes the basic drawing tools found in Cocoa and provides detailed information about how to create and manipulate everything from simple shapes to Bezier paths. </p></li>
<li class="li"><p><span class="content_text"><a href="../Images/Images.html#//apple_ref/doc/uid/TP40003290-CH208-BCIBBFGJ" data-renderer-version="1">Images</a></span> describes the image classes found in Cocoa and provides examples of how to create and manipulate images in your application.</p></li>
<li class="li"><p><span class="content_text"><a href="../Text/Text.html#//apple_ref/doc/uid/TP40003290-CH209-BCIEEIGC" data-renderer-version="1">Text</a></span> provides an overview of text and its relationship to the Cocoa drawing environment. </p></li>
<li class="li"><p><span class="content_text"><a href="../AdvancedDrawing/AdvancedDrawing.html#//apple_ref/doc/uid/TP40003290-CH207-CJBFEEJA" data-renderer-version="1">Advanced Drawing Techniques</a></span> demonstrates some advanced drawing-related techniques, including full-screen drawing, animation, gradients, and performance tuning. </p></li>
<li class="li"><p><span class="content_text"><a href="../QuartzOpenGL/QuartzOpenGL.html#//apple_ref/doc/uid/TP40003290-CH211-BAADHIAF" data-renderer-version="1">Incorporating Other Drawing Technologies</a></span> provides information and examples on how to integrate advanced technologies, such as Quartz, OpenGL, and QuickTime, into your Cocoa application.</p></li></ul>
<div id="introSeeAlsoSection"><a name="//apple_ref/doc/uid/TP40003290-CH201-DontLinkElementID_3" title="See Also"></a><h2 class="jump">See Also</h2>
<p>Drawing is only one step in the process of creating a fully functional Cocoa view. Understanding view hierarchies and how events interact with views are two other critical steps. For information about these other subjects, consult the following documents: </p>
<ul class="ul">
<li class="li"><p><em><a href="../../CocoaViewsGuide/Introduction/Introduction.html#//apple_ref/doc/uid/TP40002978" data-renderer-version="1" target="_self">View Programming Guide</a></em>—for information about creating and managing views</p></li>
<li class="li"><p><em><a href="../../EventOverview/Introduction/Introduction.html#//apple_ref/doc/uid/10000060i" data-renderer-version="1" target="_self">Cocoa Event Handling Guide</a></em>—for information about event handling</p></li></ul><p>To ensure the drawing in your app looks great on a Retina display, consult this document:</p><ul class="ul"><li class="li"><p><em><a href="../../../../GraphicsAnimation/Conceptual/HighResolutionOSX/Introduction/Introduction.html#//apple_ref/doc/uid/TP40012302" data-renderer-version="1" target="_self">High Resolution Guidelines for OS X</a></em></p></li></ul><p>Because Cocoa drawing is based on Quartz, many Quartz behaviors (though not all) are also relevant to Cocoa. This document describes the different behaviors provided by Cocoa, but for additional information about Quartz behavior, consult the following documents:</p><ul class="ul"><li class="li"><p><em><a href="../../../../GraphicsImaging/Conceptual/drawingwithquartz2d/Introduction/Introduction.html#//apple_ref/doc/uid/TP30001066" data-renderer-version="1" target="_self">Quartz 2D Programming Guide</a></em>—for conceptual information related to Quartz.  </p></li></ul></div>
        <div id="pageNavigationLinks_bottom" class="pageNavigationLinks">
            <a class='nextLink' rel='next' href='../DrawingEnviron/DrawingEnviron.html'>Next</a>
        </div><br/>
        <div class="copyright"><br/><hr /><div align="center"><p class="content_text" lang="en" dir="ltr"> Copyright &#x00a9; 2005, 2012 Apple Inc. All Rights Reserved.  <a href="http://www.apple.com/legal/internet-services/terms/site.html" target="_blank">Terms of Use</a>   |  <a href="http://www.apple.com/privacy/" target="_blank">Privacy Policy</a>  |  Updated: 2012-09-19</p></div></div>

        <div id="pediaWindow">
            <div id="pediaHeader"></div>
            <div id="pediaBody"></div>
        </div>
    </article>

    <div id="blackout">
    <div id="preload"></div>
</div>
<div id="modal" aria-hidden="true">
    <div id="closebox" tabindex="0" aria-label="Close feedback form" role="button"></div>
    <div id="sending" class="hidden">
        <h2 tabindex="0">Sending feedback&hellip;</h2>
        <div id="sending_img"></div>
    </div>
    <div id="error" class="hidden">
        <h2 tabindex="0">We&rsquo;re sorry, an error has occurred.</h2>
        <p>Please try submitting your feedback later.</p>
        <div id="error_icon"></div>
    </div>
    <div id="success" class="hidden">
        <h2 tabindex="0">Thank you for providing feedback!</h2>
        <p>Your input helps improve our developer documentation.</p>
        <div id="thank_you_icon"></div>
    </div>
    
    <form id="feedback" action="#" method="post">
        <div class="left-leaf">
            <h2 id="helpful_title" data-asterisk="a1" tabindex="0">How helpful is this document?</h2>     
            <sup id="a1" class="asterisk" aria-hidden="true">*</sup>

            <div id="star_group" role="radiogroup" aria-required="true">
                <label> 
                    <input class="radio" type="radio" name="helped" value="1" /> 
                    Very helpful
                </label>
                <label> 
                    <input class="radio" type="radio" name="helped" value="2" /> 
                    Somewhat helpful
                </label>
                <label>
                    <input class="radio" type="radio" name="helped" value="3" /> 
                    Not helpful
                </label>
            </div>
        </div>
        <div class="right-leaf">
            <h2>How can we improve this document?</h2>
            <div id="improve" class="checkboxes">
                <label>
                    <input type="checkbox" name="typo" /> 
                    Fix typos or links
                </label>
                <label>
                    <input type="checkbox" name="infoIncorrect" /> 
                    Fix incorrect information
                </label>
                <label>
                    <input type="checkbox" name="needs_examples" /> 
                    Add or update code samples
                </label>
                <label>
                    <input type="checkbox" name="needs_art" /> 
                    Add or update illustrations
                </label>
                <label>
                    <input type="checkbox" name="missingInfo" /> 
                    Add information about...
                </label>
            </div>
        </div>

        <textarea id="comment" name="problem" cols="70" rows="8" placeholder="Please tell us more about your experience with this document" data-asterisk="a2" required></textarea>
        <sup id="a2" class="asterisk" aria-hidden="true">*</sup>

        <p class="fineprint">
            <em aria-hidden="true"><span>*</span> Required information</em>
        </p> 

        <input id="submit" type="button" value="Send" />

        <section id="legal">
            <p>
                To submit a product bug or enhancement request, please visit the 
                <a href="https://developer.apple.com/bugreporter/" target="_blank">Bug Reporter</a> 
                page.
            </p>
            <p>
                Please read <a href="http://www.apple.com/legal/policies/ideas.html" target="_blank">Apple's Unsolicited Idea Submission Policy</a> 
                before you send us your feedback.
            </p> 
        </section>
    </form>
</div>

    
    <script charset="utf-8" src="../../../../../Resources/1282/JavaScript/lib/prototype.js"></script>
    <script src="../../../../../Resources/1282/JavaScript/library.js"></script>
</body>
</html>
